package hu.infokristaly.front.manager;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.Serializable;
import java.util.List;
import java.util.logging.Logger;

import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.event.PhaseId;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.commons.fileupload.util.Streams;
import org.primefaces.event.FileUploadEvent;
import org.primefaces.model.UploadedFile;

import hu.infokristaly.back.model.FileInfo;
import hu.infokristaly.back.service.FileUploadService;

@Named
@SessionScoped
public class FileUploadManager implements Serializable {

	private static final long serialVersionUID = 8877229868209535263L;

	@Inject
	private Logger logger;

	@Inject
	private FileUploadService fileUploadService;

	protected Logger getLog() {
		return logger;
	}

	private UploadedFile file;
    
    public UploadedFile getFile() {
        return file;
    }
 
    public void setFile(UploadedFile file) {
        this.file = file;
    }
	public List<FileInfo> getAllFileInfo() {
		return fileUploadService.findAllFile();
	}

	public void fileUploadListener(FileUploadEvent event) {
        if (!PhaseId.INVOKE_APPLICATION.equals(event.getPhaseId())) {
            event.setPhaseId(PhaseId.INVOKE_APPLICATION);
            event.queue();
            return;
        }
        UploadedFile file = event.getFile();
        FileOutputStream fos = null;
        FileInputStream fis = null;
        FacesMessage msg = null;
        File upFile = null;
        try {
            upFile = new File("c:/temp/" + file.getFileName());

            fos = new FileOutputStream(upFile);
            Streams.copy(file.getInputstream(), fos, true);
        } catch (IOException e) {
            msg = new FacesMessage("Feltöltés sikertelen", "[" + file.getFileName() + "," + e.getMessage() + "]");
        } finally {
            if (fis != null) {
                try {
                    fis.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
            if (fos != null) {
                try {
                    fos.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
	}
}
